/*
 *  raismth - Rai Smooth Streaming Player for linux
 *  Copyright (C) 2012 Riccardo Cioncolini | mitm@hotmail.it
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  @author: mitm(@hotmail.it) Riccardo Cioncolini
 *  @url: http://acab.servebeer.com
 */

raismth.ns(function() { with (raismth.LIB) {
myDump("[RAISMTH] engine module initialization\n");
theApp.engine = {
	grabber : function(args) {		
		// id, baseurl, vChunk, aChunk, indice, clip, ql
		let idx = args[4], indice = args[4];
		let kill = false;
		if(raismth.utils.arrayIndexOf(raismth.streams, args[0]) == -1) kill = true;
		//if(raismth.chunks[indice] > 10 && raismth.player_istances[indice] && !raismth.player_istances[indice].isRunning) kill = true;   //ghost
		if(raismth.force_kill) {
			kill = true;
			raismth.force_kill = false;
		}

		if(indice != -1 && !kill) {
			let delta = new Array();
	                let clip = args[5];
	                let ql = args[6];
	                let vindex = clip * 2;
	                let aindex = vindex + 1;
	                let vbrate = parseInt(raismth.stream_index[indice][vindex][ql][1]);
	                let abrate = parseInt(raismth.stream_index[indice][aindex][0][1]);
	                let v_next = null, a_next = null, v_payload = null, a_payload = null, v_Data = null, a_Data = null;
	                let stop = false, vskip = false, askip = false, avc = false;
			let aext = raismth.audio_ext[idx][clip];
			let vext = raismth.video_ext[idx][clip];
			myDump('[RAISMTH] Audio file extension: ' + aext + ' - Video file extension: ' + vext + '\n');
			/*
	                let aext = ".wav";
	                let vext = ".vc1";
	                if(raismth.video_encoding[idx][clip] === 'avc1') avc = true;
	                if(avc) {
	                        aext = ".aac";
	                        vext = ".avc";
	                }
			*/
			// myDump('[RAISMTH] Indice:' + indice + ' idx:' + idx + ' clip:' + clip + ' ql:' + ql + ' streams:' + raismth.streams.toString() + '\n');
			// myDump('[RAISMTH] ' + raismth.stream_index.toString() + '\n');

			if(!raismth.chunks[indice]) raismth.chunks[indice] = 0;
			if(raismth.chunks[indice] == 0) {
				raismth.engine.grabber_init(args);
			}
			if(raismth.chunks[indice] == 0 || raismth.chunks[indice] - raismth.skipped[indice] == 0) {
				raismth.avshifts[indice] = (((parseInt(args[2]) - parseInt(args[3]))/10000000)-0.15).toFixed(3);
				myDump('[RAISMTH] A/V Delay : ' + raismth.avshifts[indice] + '\n');
			}
		
			let v_url = raismth.engine.get_chunk_url(args, vbrate, true);
			let a_url = raismth.engine.get_chunk_url(args, abrate, false);

			let delay = ((parseInt(args[3]) - parseInt(args[2]))/10000000).toFixed(3);
			let starter = 5 + raismth.skipped[indice];

			if(delay > 2) { 
				a_url = false;
				askip = true;
				if(raismth.chunks[indice] < starter) vskip = true;
				raismth.skipped[indice]++;
				starter++;
				myDump('[RAISMTH] grabber - Audio Chunk skipped\n');
			} else {
				vskip = false;
			}
                        
			if(raismth.chunks[indice] == starter) {
				let vc1 = false;
				raismth.main.main_loop(args[0], false, 7, raismth.rai_windows_ts[indice], [vext, aext]);
				raismth.smthsem[indice] = false;
				raismth.sem = false;
			} else if(raismth.chunks[indice] < starter) {
				stDump('[RAISMTH] Chan ' + args[0] + ' : ' + (starter - raismth.chunks[indice]) + ' chunks left...\n', indice);
			} else if(raismth.chunks[indice] > starter) {
				if(raismth.h264[indice] == true) raismth.h264[indice] = false;
			}
			let ret = false;
			if(!askip) {
				ret = raismth.engine.grabber_run(args, a_url, aext, true, 1500);
				stop = ret[0];
				if(stop) {
					alert('[RAISMTH] Audio grabber fault');
				}
				a_next = ret[1];
				a_payload = ret[2];
			} else {
				a_next = args[3];				
			}
                        if(!stop) {
                                ret = raismth.engine.grabber_run(args, v_url, vext, !vskip, 3000, raismth.h264[indice]);
                                stop = ret[0];
				if(stop) {
                                        alert('[RAISMTH] Video grabber fault');
                                }
                                v_next = ret[1];
                                v_payload = ret[2];
                        } 
			raismth.chunks[indice]++;
			// stampa lunghezza del clip
			let clip_length = raismth.video_chunks[indice][clip].length;
			if(raismth.chunks[indice] > 5 && raismth.chunks[indice] % 10 == 0)
				stDump('[RAISMTH] Chunk [' + raismth.chunks[indice] + '/' + clip_length + ']\n', indice);

			if(args[2] == raismth.video_chunks[indice][clip][clip_length-1]) {
				if(raismth.stream_url[indice][clip].indexOf('live') == -1) stop = true;
			}

			if(!stop) {
				delta[indice] = (2000*raismth.chunks[indice]) - ((new Date()).getTime() - raismth.grabber_start_time[indice]);
				raismth.mplayer.monitor(indice, delta[indice]);
				delta[indice] = delta[indice] - 10000;
				if (delta[indice] < 0 || raismth.chunks[indice] < 6 || (raismth.chunks[indice] >= 6 && delta[indice] < 5000)) delta[indice] = 0;
				args[2] = v_next;
				if(a_next != null) args[3] = a_next;

				myDump('[RAISMTH] chunks[' + indice + ']: ' + raismth.chunks[indice] + '\n');
				myDump('[RAISMTH] v_next: ' + args[2] + ' - a_next: ' + args[3] + ' delta: ' + delta[indice] + '\n');
				raismth.smthTimers[indice] = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
				raismth.smthTimers[indice].initWithCallback(function () {raismth.engine.grabber( args )}, delta[indice], Components.interfaces.nsITimer.TYPE_ONE_SHOT);
			} else {
				raismth.chunks[indice] = 0;
				raismth.sem = false;
				raismth.smthsem[indice] = false;
				// stampa messaggio di fine clip
				stDump('[RAISMTH] End Of Stream [' + indice + ']\n');				
			}
		
			raismth.engine.log(indice, v_url, a_url, v_next, a_next, v_payload, a_payload);
		} else {
			myDump('[RAISMTH] Stream ' + args[0] + ' eof\n');
			myDump('[RAISMTH] rai_windows: ' + raismth.rai_windows.toString() + '\n');
			myDump('[RAISMTH] rai_windows_ts: ' + raismth.rai_windows_ts.toString() + '\n');
		}

	},
        timer : function(timeout, indice) {		
                myDump('[RAISMTH] Network Monitor Init\n');
		raismth.ctrlTimers[indice] = 1;
                raismth.smthTimers[indice] = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
                raismth.smthTimers[indice].initWithCallback(function() { raismth.engine.timerclock(indice); }, timeout, Components.interfaces.nsITimer.TYPE_REPEATING_PRECISE);
        },

        timerkill : function(indice){
                myDump('[RAISMTH] Network Monitor Kill\n');
		raismth.smthTimers[indice].cancel();
		if(raismth.ctrlTimers[indice] > 2) {
			raismth.ctrlTimers[indice] = 0;
			myDump('[RAISMTH] timerkill calling management\n');
			raismth.mplayer.management(indice, true);
		}
        },

        timerclock : function(indice) {
                myDump('[RAISMTH] Network Monitor Clock ' + indice + '\n');
		myDump('[RAISMTH] timerclock calling management\n');
		raismth.mplayer.management(indice);
        },

	grabber_init : function(args){
		myDump('[RAISMTH] [' + args[0] + '] Grabber init \n');
		let now = (new Date()).getTime();
		raismth.h264[args[4]] = false;
		raismth.smthsem[args[4]] = true;
		raismth.grabber_start_time[args[4]] = now;
		raismth.utils.vfile_init(args[0], args[4], args[5], args[6]);
		raismth.utils.afile_init(args[0], args[4], args[5], args[6]);
		raismth.faad_sem[args[4]] = false;
		raismth.faad_decoding_buffer[args[4]] = null;
		raismth.skipped[args[4]] = 0;
	},

	grabber_run : function(args, url, ext, write, to, h) {
		raismth.engine.timer(to, args[4]);
		let data = raismth.utils.wget(url, false);
		raismth.engine.timerkill(args[4]);
		let stop = false;
		let payload = null;
		let next = null;
		
		if(data) {
			next = raismth.utils.bin2hex(data.substr(data.lastIndexOf("=uuid")+26, 8));
			payload = data.substr(data.lastIndexOf("mdat")+4);
		} else {
			// TODO: retry
		}
		
		if(write && !raismth.utils.write_bin(payload, args[0] + ext, args[4], args[5], args[6], h)) {
			stop = true;
			// TODO: add controls
		}
		let ret = new Array();	
		ret[0] = stop;
		ret[1] = next;
		ret[2] = payload;
		return ret;			
	}, 	

	get_chunk_url : function(args, brate, tipo) {
		let target = null;
		let start = null;
		if(tipo) {
			target = raismth.video_templ[args[4]][args[5]];
			start = args[2];
		} else {
			target = raismth.audio_templ[args[4]][args[5]];
			start = args[3];
		}
		let url = args[1] + target;
		url = url.replace(/{bitrate}/i, brate);
		url = url.replace(/{start time}/i, start);
		return url;
	},

	log : function(indice, v_url, a_url, v_next, a_next, v_payload, a_payload) {
		myDump('[RAISMTH] ' + indice + ' - v_url    : ' + (v_url ? v_url : 'null') + '\n');
		myDump('[RAISMTH] ' + indice + ' - a_url    : ' + (a_url ? a_url : 'null') + '\n');
		myDump('[RAISMTH] ' + indice + ' - v_next   : ' + (v_next ? v_next : 'null') + '\n');
		let vsize = 'null';
		if(v_payload != null) vsize = v_payload.length;
		myDump('[RAISMTH] ' + indice + ' - v_payload: ' + vsize + '\n');
		myDump('[RAISMTH] ' + indice + ' - a_next   : ' + (a_next ? a_next : 'null') + '\n');
		let asize = 'null';
		if(a_payload != null) asize = a_payload.length;
		myDump('[RAISMTH] ' + indice + ' - a_payload: ' + asize + '\n');
	},
}

}});
