/*
 *  raismth - Rai Smooth Streaming Player for linux
 *  Copyright (C) 2012 Riccardo Cioncolini | mitm@hotmail.it
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  @author: mitm(@hotmail.it) Riccardo Cioncolini
 *  @url: http://acab.servebeer.com
 */

raismth.ns(function() { with (raismth.LIB) {
var before = null;
var after = null;
var dl_time = false;
var mData = null;
var loop_timer = null;
var target = null;
var smthtarget = null;
var windowid = null;
var retr = 0;
var last_loop = new Array();
myDump("[RAISMTH] main module initialization\n");

theApp.main = {
		// funzione per riprodurre il prossimo clip nella coda
		playNextQueued : function(indice)
		{
			if (raismth.playQueueIdx[indice] == -1 || raismth.playQueue[indice].length == 0 || raismth.playQueueIdx[indice] >= raismth.playQueue[indice].length)
			{
				raismth.playQueueIdx[indice] = -1;
				return;
			}
			
			let i = raismth.playQueueIdx[indice];
			raismth.playQueueIdx[indice]++;
			
			let clip = raismth.playQueue[indice][i].clip;
			let ql = raismth.playQueue[indice][i].ql;
			
			let video_chunk = raismth.video_chunks[indice][clip][0];
			let audio_chunk = raismth.audio_chunks[indice][clip][0];
			let url = raismth.stream_url[indice][clip];
			let windowid = raismth.rai_windows_ts[indice];
			let doc = raismth.rai_windows[indice];
			raismth.main.main_loop(url, [video_chunk, audio_chunk, indice, clip, ql], 6, windowid);
		},
		
        main_loop : function(url,ttauth,action,id,vc1) {
		let indice = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(id));
		myDump('[RAISMTH] main loop entry indice:' + indice + ' action:' + action + ' ts:' + id + '\n');
		if( ( action === 6 && url != null && raismth.rai.isPlaying(ttauth[0]) ) || (action === 0 && raismth.rai.isPlaying(url) ) ){
			stDump('[RAISMTH] Content Already Playing url: ' + url + ' ttauth:' + ttauth[0] + '\n', indice);
			raismth.sem = false;
			return false;
		}
		

                if(action == 0 && id != null) {
			myDump('[RAISMTH] action: 0 indice:' + indice + '\n');
			if(!last_loop[indice]) {
				myDump('[RAISMTH] id : ' + id + '\n');
				myDump('[RAISMTH] indice : ' + indice + '\n');
				last_loop[indice] = new Array();
				for(let i=0; i<arguments.length; i++) {
					last_loop[indice][i] = arguments[i];
					myDump('[RAISMTH] args[i] => ' + last_loop[indice][i] + '\n');
				}
			}
		}
		let replay = false;

		if(action < 6 && url != null && (url.indexOf('csm') != -1 || url.indexOf('ism') != -1)) {
			if(url.indexOf('csm') != -1) {
				target = url;
				replay = true;
			}
			action = 2;
		}

		if(action == 6 && url != null) {
			smthtarget = url;
			target = ttauth[0];
		}


		if(url === null) url = target; //

		if(id != null) {
			windowid = id;
		}
		mData = url;
		let process = null;
		
		if(action < 5) {
			before = (new Date()).getTime();
			let to = 5000;
			to += 2*1000*retr;
			if(action == 1) to = 20000;
			raismth.main.main_loop_timer(to, indice);
			dl_time = false;
			mData = raismth.utils.wget(url, ttauth);
			after = (new Date()).getTime();
			dl_time = after - before;
			if(!mData) dl_time = false;
			raismth.main.main_loop_check(indice);
		}

		if((raismth.sem && mData != null) || action >= 5) {
			stDump('[RAISMTH] Main Loop: Step ' + action + '\n', indice);
			switch(action){
			case 0:
				target = url;
				raismth.parsers.parsemData(mData, id);
				break;
			case 1:
				raismth.parsers.parseNTPData(mData, id);
				break;
			case 2:
				let idx = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(windowid));
				smthtarget = url;
				raismth.parsers.parseManifest(mData, idx, replay);
				if(raismth.stream_url[idx][0] == '') myDump('[RAISMTH] ' + raismth.stream_url[idx][0] + '>> no stream url, live smth\n');
				if(raismth.stream_url[idx][0] == '') raismth.stream_url[idx][0] = url;
				break;
			case 3:
				break;
			case 4:
				break;
			case 5:
				stDump('[RAISMTH] Starting mms player\n', indice);
				myDump('[RAISMTH] 5: URL:' + url + '\n');
				myDump('[RAISMTH] 5: TARGET:' + target + '\n');
				myDump('[RAISMTH] 5: WINID:' + windowid + '\n');
				myDump('[RAISMTH] 5: WINTS:' + raismth.rai_windows_ts.toString() + '\n');
				let isRadio = raismth.rai_windows[indice].location.href.toLowerCase().indexOf('radio');
				isRadio = isRadio === -1 ? false : true;
				myDump('[RAISMTH] 5: ISRADIO:' + isRadio + '\n');
				process = raismth.player.load(url, false, windowid, null, isRadio);
				if(!process) {
					alert('error');
				} else {
					indice = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(windowid));
					raismth.player_istances[indice] = process;
					if(target == null) target = url;
					let contents = target;
					if(url.search('=') != -1) {
						contents = target.substring(target.lastIndexOf('=') + 1);
					} else if(url.search('/') != -1) {
						contents = target.substring(target.lastIndexOf('/') + 1);
					}
					raismth.player_istances_pid[indice] = contents;
					stDump('[RAISMTH] Mms Player Started [Filling 512 KByte cache] - WinID: ' + indice + '\n', indice);
				}
				target = null;
				smthtarget = null;
				raismth.sem = false;
				break;
			case 6:
				indice = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(windowid));
				if (smthtarget != null) url = smthtarget;
				myDump('[RAISMTH] ' + url + ' <- url\n');
				smthtarget = smthtarget.substring(0, smthtarget.lastIndexOf('/') + 1);
				// smthtarget = smthtarget.substring(0, smthtarget.indexOf('Manifest') != -1 ? smthtarget.indexOf('Manifest') : smthtarget.indexOf('manifest'));
				let outfile = (target.search('=') != -1) ? target.substring(target.lastIndexOf('=') + 1) : target.substring(target.lastIndexOf('/') + 1);
				ttauth.unshift(smthtarget);
				ttauth.unshift(outfile);

				raismth.streams[indice] = outfile;

				myDump('[RAISMTH] 6: Smthtarget:' + smthtarget + '\n');
				myDump('[RAISMTH] 6: Outfile:' + outfile + '\n');
				myDump('[RAISMTH] 6: ttauth:' + ttauth.toString() + '\n');
				myDump('[RAISMTH] 6: URL:' + url + '\n');
				myDump('[RAISMTH] 6: TARGET:' + target + '\n');
				myDump('[RAISMTH] 6: WINID:' + windowid + '\n');
				
				raismth.engine.grabber(ttauth);

				target = null;
				smthtarget = null;
				break;
			case 7:
				indice = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(windowid));
				stDump('[RAISMTH] Starting Smth player\n', indice);
				myDump('[RAISMTH] 7: URL:' + url + '\n');
				myDump('[RAISMTH] 7: ID/TS:' + id + '\n');
				myDump('[RAISMTH] 7: Indice:' + indice + '\n');
				process = raismth.player.load(url, true, indice, vc1);
				if(!process) {
					alert('error');
				} else {
					raismth.player_istances[indice] = process;
					raismth.player_istances_pid[indice] = url;
					raismth.rai_active_channels[indice] = url;
					// raismth.h264[indice] = true;
					myDump('[RAISMTH] ' + raismth.rai_active_channels.toString() + ' active_channels - indice:' + indice + '\n'); 
					stDump('[RAISMTH] Smth Player Started\n', indice);
				}
				raismth.sem = false;
				break;
			}
		} 
        },

	main_loop_timer : function(timeout, indice) {
		myDump('[RAISMTH] Main Loop Timer Init indice:' + indice + ' timeout:' + timeout + '\n');
		loop_timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		loop_timer.initWithCallback(function() { raismth.main.notify(indice); }, timeout, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	},

	main_loop_check : function(indice){
		myDump('[RAISMTH] Mail Loop Timer Kill indice:' + indice + '\n');				  
		loop_timer.cancel();
		if(!dl_time) {
			retr++;
			if(retr < 11) {
				myDump('[RAISMTH] Network timeout [' + (5000 + (2*1000*retr)) + '], retrying...\n');
				myDump('[RAISMTH] retr  : ' + retr + '\n');
				myDump('[RAISMTH] indice: ' + indice + '\n');
				stDump('[RAISMTH] Timeout connecting to remote server, retrying [' + retr + '/10]\n', indice);
				myDump('[RAISMTH] ' + last_loop[indice].toString() + '\n');
				raismth.main.main_loop(last_loop[indice][0], last_loop[indice][1], last_loop[indice][2], last_loop[indice][3], last_loop[indice][4]);
			} else {
				myDump('[RAISMTH] Timeout connecting to remote server\n');
				stDump('[RAISMTH] Network timeout\n', indice);
				raismth.sem = false;
				retr = 0;
			}
		} else {
			retr = 0;
		}
	},

	notify : function(indice) {
		myDump('[RAISMTH] Main Loop Timer Clock\n');
		raismth.main.main_loop_check(indice);
	},


}

}});

