raismth.ns(function() { with (raismth.LIB) {
myDump("[RAISMTH] player module initialization\n");

theApp.myObserver = {
        init : function() {
                this.register();
        }
}
theApp.myObserver.prototype = {	
        observe: function(subject, topic, data) {
                let process = subject.QueryInterface(Components.interfaces.nsIProcess);
                if(process.exitValue == 0 || topic == "process-finished") {
			//if(raismth) raismth.player.shutdown(); //ghost
                }
                this.unregister();
        },

        register: function() {
                myDump('[RAISMTH] Registering player-observer-component\n');
                let observerService = Components.classes["@mozilla.org/observer-service;1"]
                        .getService(Components.interfaces.nsIObserverService);
                observerService.addObserver(this, "myTopicID", false);
        },

        unregister: function() {
                myDump('[RAISMTH] Un-registering player-observer-component\n');
                let observerService = Components.classes["@mozilla.org/observer-service;1"]
                        .getService(Components.interfaces.nsIObserverService);
                observerService.removeObserver(this, "myTopicID");
        },
}

theApp.player = {
	pref : function(player, id, uri, smooth, vc1, isRadio) {
		let params = new Array();
		let mplayer = false;		       
		if(smooth) mplayer = true;
		if(player.indexOf('mplayer') != -1 && player.indexOf('wmplayer') == -1) mplayer = true;
		if(mplayer) {
			if(raismth.sep == "/") { //linux only
				params.push('-stop-xscreensaver');
				if(raismth.mplayer_fifo && smooth) {
					params.push('-slave');
					params.push('-input');
					params.push('file=/tmp/mplayer-fifo-' + id);
				}
			}

			params.push('-nokeepaspect');
			params.push('-noconsolecontrols');

			if(raismth.player_aspect) {
				params.push('-aspect');
				params.push(raismth.player_aspect);
			}

			if(raismth.x11) {
				params.push('-zoom');
				params.push('-vo');
				params.push('x11');
			}

			if(raismth.fs) {
				params.push('-fs');
			}

			if(raismth.wintop) {
				params.push('-ontop');
			}

			if(smooth) {
				if(raismth.mplayer_faad) {
					/*
					params.push('-rawaudio')
					params.push('channels=2:rate=48000:bitrate=64000:format=255');
				       	params.push('-demuxer');
				        params.push('rawaudio');
					*/
				}
				// params.push('-autosync');
				// params.push('60');
				params.push('-mc');
				params.push('0');
				params.push('-delay');
				params.push(raismth.avshifts[id]);
				let vext = vc1[0];
				let aext = vc1[1];
				if(vext === '.vc1'){
					params.push('-vc');
					params.push('ffvc1');
				} 
				if(raismth.wmadmo && vext === '.vc1') {
                                        params.push('-ac');
					params.push('wmadmo');
				}
				params.push('-audiofile');
				params.push(raismth.temp_folder.path + raismth.sep + uri + aext);
				params.push(raismth.temp_folder.path + raismth.sep + uri + vext);
			} else {
				// params.push('-nocache');
				if(!isRadio) {
					params.push('-cache');
					params.push('512');
					params.push('-cache-min');
					params.push('50');
				}	
				if(uri.indexOf('wmv') != -1) uri = uri.replace('http', 'mms');
				params.push(uri);
			}
		} else {
			// other players options here
			params.push(uri);
		}
		return params;
	},
        load : function (uri, smooth, id, vc1, isRadio) {
		let retvalue = null;		
                let nsILocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
                let nsIProcess = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);

                let Prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		let player_path = smooth ? Prefs.getCharPref("extensions.raismth.smth-player-path") : Prefs.getCharPref("extensions.raismth.mmsh-player-path"); 
		// enforce control on player path
		try {
			nsILocalFile.initWithPath(player_path);
		} catch (e) {
			alert('Incorrect player path');
		} finally {
			if(nsILocalFile.exists()){
				let paramArray = raismth.player.pref(player_path, id, uri, smooth, vc1, isRadio);
				myDump('[RAISMTH] paramArray : ' + paramArray.toString() + "\n");
				nsIProcess.init(nsILocalFile);
				let observer = raismth.myObserver;
				observer.init();
				nsIProcess.runAsync(paramArray, paramArray.length, observer);
				retvalue = nsIProcess;
			} else {
				retvalue = false;
			}
		}
		return retvalue;
        },
	
	shutdown : function() {
                let pid = null;
		let conta = raismth.player_istances.length;
		for(let c = 0; c < raismth.player_istances.length; c++) {
			if(raismth.player_istances[c] && !raismth.player_istances[c].isRunning && raismth.player_istances_pid[c] != null) {
				pid = raismth.player_istances_pid[c];
				let chan_index = c;
				// valuta la condizione di fine clip (vedi engine.js grabber)
				let clipFinished = (raismth.chunks[chan_index] == 0 && !raismth.smthsem[chan_index]);
				stDump('[RAISMTH] Player Stop/EOF pid:' + pid + ' c:' + c + ', ' + (clipFinished ? 'END OF CLIP' : 'ERROR') + '\n', c);
				raismth.rai_active_channels[chan_index] = null;
				raismth.chunks[chan_index] = null;
				raismth.player_istances[chan_index] = null;
				raismth.player_istances_pid[chan_index] = null;
				raismth.streams[chan_index] = null;
				raismth.grabber_start_time[chan_index] = null;

				raismth.utils.clean_temp_files(pid);
				
				// se Ã¨ attiva la coda di riproduzione di 'play all', lancia il prossimo filmato tra 2s
				if (theApp.playQueueIdx[chan_index] != -1)
				{
					let t = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
					t.initWithCallback(function() { raismth.main.playNextQueued(chan_index); }, 2000, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
				}
				break;
			}
		}
	},			   

};

theApp.myObserver.__proto__ = theApp.myObserver.prototype;

}});
