raismth.ns(function() { with (raismth.LIB) {
myDump("[RAISMTH] utils module initialization\n");

theApp.utils =
{
        go : function(uri){
		window.open(uri, "", "chrome"); 
	},

	get_temp : function() {
		let temp = false;
		try{
			temp = Components.classes["@mozilla.org/file/directory_service;1"].
			getService(Components.interfaces.nsIProperties).
			get("TmpD", Components.interfaces.nsIFile);
		} catch (e) {
			alert('[RAISMTH] Unable to fetch Temp folder: ' + e);
		} finally {
			// temp = temp.path;
		}

		return temp;
	},
	
	set_os : function () {
		let temp = raismth.utils.get_temp();
		if(!temp) return false;
		if(temp.path.indexOf(':') == -1) {
			// alert('Linux OS detected');
			raismth.sep = "/";
			if(raismth.mplayer.fifo_init(0)) raismth.mplayer_fifo = true;
		} else {
			// alert('Windows OS detected');
			raismth.sep = "\\";
		}
		raismth.temp_folder = temp;
		return true;
	},

	check_paths : function (aPath) {	
		let success = false;
		if(aPath) {
			let path = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);			      
			try{
				path.initWithPath( aPath );
				success = path;
			} catch(e) {
				success = false;
				// alert(e);
			} 
		}
		return success;
	},			      

	check_pref : function (path, bin){
		let success = false;			      
		if(bin)	{
			if(path.exists() && path.isExecutable()) success = true;
		} else {
			if(path.exists() && path.isWritable()) success = true;
		}
		return success;
	},
		      
        load_prefs : function() {
		let success = true;
		raismth.prefs = Components.classes["@mozilla.org/preferences-service;1"]
                         .getService(Components.interfaces.nsIPrefService)
                         .getBranch("extensions.raismth.");
	        raismth.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		raismth.prefs.addObserver("", this, false);
		raismth.x11 = raismth.prefs.getBoolPref("mplayer-x11");
		raismth.wmadmo = raismth.prefs.getBoolPref("mplayer-wmadmo");
		raismth.wintop = raismth.prefs.getBoolPref("mplayer-top");
		raismth.player_aspect = raismth.prefs.getCharPref("mplayer-aspect");
		raismth.fs = raismth.prefs.getBoolPref("mplayer-fs");
		raismth.debug = raismth.prefs.getBoolPref("debug");
		raismth.ntpbypass = raismth.prefs.getBoolPref("ntp-bypass");

		let chan1 = raismth.prefs.getIntPref("user-chan1");
		if(typeof(chan1) === 'number') raismth.chan[0] = chan1;
		let chan2 = raismth.prefs.getIntPref("user-chan2");
		if(typeof(chan2) === 'number') raismth.chan[1] = chan2;
		let chan3 = raismth.prefs.getIntPref("user-chan3");
		if(typeof(chan3) === 'number') raismth.chan[2] = chan3;


		let temp_folder = raismth.utils.check_paths(raismth.prefs.getCharPref("smth-player-temp"));
		if(temp_folder && raismth.utils.check_pref(temp_folder, false)) {
			raismth.temp_folder = temp_folder;
		} 
		// raismth.prefs.setComplexValue("smth-player-temp", Components.interfaces.nsILocalFile, raismth.temp_folder);

		let mms_player = raismth.utils.check_paths(raismth.prefs.getCharPref("mmsh-player-path"));
		if(mms_player && raismth.utils.check_pref(mms_player, true)) {
			raismth.mms_player = mms_player;
			// raismth.prefs.setComplexValue("mmsh-player-path", Components.interfaces.nsILocalFile, raismth.mms_player);
		} else {
			alert('Plz check your settings about mms player path\nmplayer, vlc, windows media player, totem...\n\nRaismth How-To:\nhttps://addons.mozilla.org/it/firefox/addon/raismth/');
			raismth.utils.go('chrome://raismth/content/options.xul');
			success = false;
		}

		let smth_player = raismth.utils.check_paths(raismth.prefs.getCharPref("smth-player-path")); 
		if(smth_player && raismth.utils.check_pref(smth_player, true)) {
			raismth.smth_player = smth_player;
			// raismth.prefs.setComplexValue("smth-player-path", Components.interfaces.nsILocalFile, raismth.smth_player);
		} else {
			alert('Plz check your settings about smth player path\nmplayer [http://www.mplayerhq.hu]\n\nRaismth How-To:\nhttps://addons.mozilla.org/it/firefox/addon/raismth/');
			if(success) raismth.utils.go('chrome://raismth/content/options.xul');
			success = false;
		}

		let audio_decoder = raismth.utils.check_paths(raismth.prefs.getCharPref("audio-decoder-path"));
		if(audio_decoder && raismth.utils.check_pref(audio_decoder, true)) {
			raismth.audio_decoder = audio_decoder;
			// raismth.prefs.setComplexValue("audio-decoder-path", Components.interfaces.nsILocalFile, raismth.audio_decoder);
		} else {
			alert('Plz check your settings about audio decoder path\nfaad2 [www.audiocoding.com/faad2.html]\n\nRaismth How-To:\nhttps://addons.mozilla.org/it/firefox/addon/raismth/');
			if(success) raismth.utils.go('chrome://raismth/content/options.xul');
			success = false;
		}
		return success;
        },

        observe: function(subject, topic, data) {
                if (topic != "nsPref:changed")
                {
                        return;
                }
                switch(data)
                {
                        case "mplayer-x11":
                                raismth.x11 = raismth.prefs.getBoolPref("mplayer-x11");
                        break;

			case "mplayer-wmadmo":
				raismth.wmadmo = raismth.prefs.getBoolPref("mplayer-wmadmo");
			break;

                        case "mplayer-top":
                                raismth.wintop = raismth.prefs.getBoolPref("mplayer-top");
                        break;

                        case "mplayer-aspect":
                                raismth.player_aspect = raismth.prefs.getCharPref("mplayer-aspect");
                        break;

                        case "mplayer-fs":
                                raismth.fs = raismth.prefs.getBoolPref("mplayer-fs");
                        break;

			case "user-chan1":
		                let chan1 = raismth.prefs.getIntPref("user-chan1");
				if(typeof(chan1) === 'number') raismth.chan[0] = chan1;
			break;

			case "user-chan2":
				let chan2 = raismth.prefs.getIntPref("user-chan2");
				if(typeof(chan2) === 'number') raismth.chan[1] = chan2;
			break;
			
			case "user-chan3":
				let chan3 = raismth.prefs.getIntPref("user-chan3");
				if(typeof(chan3) === 'number') raismth.chan[2] = chan3;
			break;


                        case "smth-player-temp":
		                let temp_folder = raismth.utils.check_paths(raismth.prefs.getCharPref("smth-player-temp"));
				if(temp_folder && raismth.utils.check_pref(temp_folder, false)) {
					raismth.temp_folder = temp_folder;
					myDump('[RAISMTH] ' + data + ' path fetched\n');
					stDump('[RAISMTH] ' + data + ' path fetched\n');
				} else {
					myDump('[RAISMTH] ' + data + ' directory not fetched/writable\n');
					stDump('[RAISMTH] ' + data + ' directory not fetched/writable\n');
				}
                        break;

			case "smth-player-path":
				let smth_player = raismth.utils.check_paths(raismth.prefs.getCharPref("smth-player-path"));
				if(smth_player && raismth.utils.check_pref(smth_player, true)) {
					raismth.smth_player = smth_player;
					myDump('[RAISMTH] ' + data + ' path fetched\n');
					stDump('[RAISMTH] ' + data + ' path fetched\n');
				} else {
					myDump('[RAISMTH] Plz check your settings about ' + data + '\n');
					stDump('[RAISMTH] Plz check your settings about ' + data + '\n');
				}
			break;

			case "mmsh-player-path":
				let mms_player = raismth.utils.check_paths(raismth.prefs.getCharPref("mmsh-player-path"));
				if(mms_player && raismth.utils.check_pref(mms_player, true)) {
					raismth.mms_player = mms_player;
					myDump('[RAISMTH] ' + data + ' path fetched\n');
					stDump('[RAISMTH] ' + data + ' path fetched\n');
				} else {
					myDump('[RAISMTH] Plz check your settings about ' + data + '\n');
					stDump('[RAISMTH] Plz check your settings about ' + data + '\n');
				}
			break;

			case "audio-decoder-path":
				// let audio_decoder = raismth.prefs.getComplexValue("audio-decoder-path", Components.interfaces.nsILocalFile);
				let audio_decoder = raismth.utils.check_paths(raismth.prefs.getCharPref("audio-decoder-path"));
				if(audio_decoder && raismth.utils.check_pref(audio_decoder, true)) {
					raismth.audio_decoder = audio_decoder;
					myDump('[RAISMTH] ' + data + ' path fetched\n');
					stDump('[RAISMTH] ' + data + ' path fetched\n');
				} else {
					 myDump('[RAISMTH] Make sure the audio decoder (faad2 - www.audiocoding.com/faad2.html) is installed and check your settings about ' + data + '\n');
					 stDump('[RAISMTH] Make sure the audio decoder (faad2 - www.audiocoding.com/faad2.html) is installed and check your settings about ' + data + '\n');
				}
			break;

                        case "debug":
                                raismth.debug = raismth.prefs.getBoolPref("debug");
                        break;
			
			case "ntp-bypass":
				raismth.ntpbypass = raismth.prefs.getBoolPref("ntp-bypass");
			break;
                }
	},

        goext : function(uri) {
                let opt = false;
		let url = uri.substring(0, uri.indexOf('?'));
		let pattern_1 = uri.indexOf("popup") + 6;
		let pattern_2 = uri.indexOf("&", pattern_1);
		let popup = uri.substring(pattern_1, pattern_2);
		if (popup.toString() == 'true') opt = true; 
		if(opt) { 
	                pattern_1 = uri.indexOf("?");
	                pattern_2 = uri.indexOf("&", pattern_1);
	                let width = uri.substring(pattern_1 + 7, pattern_2);
	                pattern_1 = uri.indexOf("height") + 7;
	                pattern_2 = uri.indexOf("&", pattern_1);
	                let height = uri.substring(pattern_1, pattern_2);
			opt = "menubar=0,resizable=1,width=" + width + ",height=" + height + ",location=0,status=0,scrollbars=1";
			// dump(opt + '\n');
		} else {
			opt = "";
		}

		let a = false;
		if(uri.indexOf("a=") !== -1) a = true;
		if(a === true) window.open(url, "raismth", opt);

        },

	version_check : function (sUrl, fCallback) {
		let aRefDoc = Array.prototype.slice.call(arguments, 2);
                let now = (new Date()).getDay();
                let lastseen = raismth.prefs.getCharPref("lastseen");
		if(lastseen != now) {
			raismth.prefs.setCharPref("lastseen", now);
			raismth.lastseen = "";
			raismth.daily_url = null;
		}

		if(raismth.daily_url === null || lastseen != now) {
			let oXHR = new XMLHttpRequest();  
		      	oXHR.onreadystatechange = function() {
			    	if (oXHR.readyState === 4) { fCallback.apply(oXHR, aRefDoc); }
		      	};
		      	oXHR.open("GET", sUrl, true);
		      	oXHR.send(null);
		} else {
			fCallback.apply(this, aRefDoc);	
		}
	},

	showMessage : function (aDoc) {
		let logo = aDoc.getElementById('raismthLogo');
		let now = (new Date()).getDay();
		let href = "https://addons.mozilla.org/it/firefox/addon/raismth/";
		if(this.status && this.status === 200) {
			href = this.responseText;
		} else {
			// Not a xhr || xhr failed
		}
		if(raismth.daily_url !== null ) {
			href = raismth.daily_url; // use cached url
		} else {
			raismth.daily_url = href; // set daily url
		}
		
		if(raismth.lastseen === "") {
			raismth.utils.goext(href);
			raismth.lastseen = now;
		}
		if(logo){
			let div = aDoc.createElement('div');
			div.setAttribute('style', 'font-weight:bold;font-size:8px;color:white');
			let ref = aDoc.createElement('a');
			ref.setAttribute('style', 'font-weight:bold;font-size:8px;color:white');
			ref.setAttribute('href', href);
			ref.setAttribute('target', '_blank');						
			let html = 'Click here to support RAISMTH development';
			let testo = aDoc.createTextNode(html);
			ref.appendChild(testo);
			div.appendChild(ref);
			let noderef = logo.childNodes[0];
			logo.insertBefore(div, noderef);
			// raismth.rai.injectRaismthStatus(aDoc);
			// logo.childNodes[0].appendChild(div);
		}
		// alert(sMsg + this.responseText);     
	},

        wget : function (url, ttauth) {
		myDump('[RAISMTH] wget uri:' + url + '\n');
                raismth.url = url;
                let ioserv = Components.classes["@mozilla.org/network/io-service;1"]
                        .getService(Components.interfaces.nsIIOService);
                let channel = ioserv.newChannel(url, 0, null);
                channel.QueryInterface(Components.interfaces.nsIHttpChannel);

                if(ttauth != false){
                        channel.requestMethod = "POST";			
                        channel.setRequestHeader("ttauth", ttauth, false);
                        channel.setRequestHeader("viaurl", "www.rai.tv", false);
                }
                /*
                if(raismth.utf8){
                        channel.setRequestHeader("Content-Type", "text/xml; charset=UTF-8", false);
                        channel.setRequestHeader("Content-Type", "text/xml" + "; charset=UTF-8", false);
                }
                */
                let stream = channel.open();
		if(!channel.responseStatus) return false;
                if (channel.responseStatus == 302) return(channel.getResponseHeader('Location'));
                if (channel.responseStatus != 200) {
                        return false;
                }
                // if (channel instanceof Components.interfaces.nsIHttpChannel && channel.responseStatus != 200) {
                //      return "";
                // }

                let bstream = Components.classes["@mozilla.org/binaryinputstream;1"]
                        .createInstance(Components.interfaces.nsIBinaryInputStream);
                bstream.setInputStream(stream);
                let size = 0;
                let file_data = "";
                while(size = bstream.available()) {
                        file_data += bstream.readBytes(size);
                }
                return file_data;
        },
	       
	aac_lc_decode : function(infile, sampling) {
		let retvalue = false;				
                let nsILocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
                let nsIProcess = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);

                let Prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		let decoder_path = raismth.audio_decoder.path; 
		// enforce control on player path
                try {
                        nsILocalFile.initWithPath(decoder_path);
                } catch (e) {
                        alert('Check decoder path');
			raismth.sem = false;
                } finally {
                        if(nsILocalFile.exists()){
				let fileout = raismth.temp_folder.path + raismth.sep + infile + '.aac';
				let outlocale = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				try{
					outlocale.initWithPath(fileout);
					if(outlocale.exists()) {
						outlocale.remove(false);
						myDump('[RAISMTH] ' + fileout + ' removed\n');
					}
				} catch (e) {
					// alert('error');
				} finally {
					// if(outlocale.exists()) outlocale.remove(false);
				}

                                let paramArray = new Array(); 
				paramArray.push(raismth.temp_folder.path + raismth.sep + infile + ".tmp");
		
				// paramArray.push('-q');
				paramArray.push('-l');
				paramArray.push('2');
				paramArray.push('-s');
				paramArray.push(sampling);
				paramArray.push('-a');
				paramArray.push(raismth.temp_folder.path + raismth.sep + infile + ".aac");
				
                                nsIProcess.init(nsILocalFile);
                                nsIProcess.run(true, paramArray, paramArray.length);
                                retvalue = nsIProcess;
				// myDump(paramArray.toString() + ' <--- faad cmd line\n');
                        } else {
                                retvalue = false;
                        }
                }
		return retvalue;
  	},
	decoder_init : function(outfile, sampling) {
		if(raismth.utils.aac_lc_decode(outfile, sampling)) return true;
		return false;
	},			      
	write_temp : function(data, outfile){
		let target = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		let path = raismth.temp_folder.path + raismth.sep + outfile + ".tmp";
		target.initWithPath( path );
		try{
			if(target.exists()) {
				target.remove(false);
				myDump('[RAISMTH] ' + path + ' removed\n');
			}
		} catch (e) {
			alert('Error deleting temp file');
		}

		let stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		stream.init(target, 0x04 | 0x08 | 0x20, 0600, 0);
		stream.write(data, data.length);		
		if (stream instanceof Components.interfaces.nsISafeOutputStream) {  
			stream.finish();  
		} else {
 			stream.close();  
		}
		myDump('[RAISMTH] Temp Data length: ' + data.length + ' - Outfile: ' + outfile + '.tmp\n');
	},
	read_temp : function(outfile) {
		let ios = Components.classes["@mozilla.org/network/io-service;1"].
			getService(Components.interfaces.nsIIOService);
		let binFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		binFile.initWithPath( raismth.temp_folder.path + raismth.sep + outfile + ".aac" ) ;
		let istream = Components.classes["@mozilla.org/network/file-input-stream;1"].  
			              createInstance(Components.interfaces.nsIFileInputStream);  
		istream.init(binFile, -1, -1, false);  
		  
		let bstream = Components.classes["@mozilla.org/binaryinputstream;1"].  
			              createInstance(Components.interfaces.nsIBinaryInputStream);  
		bstream.setInputStream(istream);  
		  
		let bytes = bstream.readBytes(bstream.available()); 
		return bytes;
	},
	decode_avc : function(data) {
		// myDump('[RAISMTH] ' + data.length + " <-- length \n");
		let payload = '';
		let size = 0;
		let before = (new Date()).getTime();
		for(let c = 0; c < data.length; c+=size+4) {
			size = raismth.utils.bin2Hex(data.substr(c, 4));
			payload += "\x00\x00\x00\x01" + data.substr(c + 4, size);
		}
		let after = (new Date()).getTime();
		let delay = after - before;
		myDump('[RAISMTH] AVC Decoding took: ' + delay + ' ms, payload size: ' + payload.length + '\n');
		return payload;
	},	 		     
		     
	decode_data : function (data, outfile, idx, clip) {
		let decoded = data;		
  		let faad = false; //fixme
		let avc = false;

		myDump('[RAISMTH] Audio Encoding: ' + raismth.audio_encoding[idx][clip] + ' <----- \n');
		myDump('[RAISMTH] Video Encoding: ' + raismth.video_encoding[idx][clip] + ' <----- \n');
		if(raismth.audio_encoding[idx][clip] == 'aacl') faad = true;
		if(raismth.video_encoding[idx][clip] == 'avc1') avc = true;

		if(outfile.indexOf(raismth.audio_ext[idx][clip]) > 0 && faad) {
			raismth.faad_decoding_buffer[idx] = data;
			if(raismth.chunks[idx] % 1 == 0) {
				let a = (2 * clip) + 1;
				let faad_opt = raismth.stream_index[idx][a][0][6];
				myDump('[RAISMTH] sampling rate : ' + faad_opt + '\n');
				raismth.utils.write_temp(raismth.faad_decoding_buffer[idx], outfile);
				let success = raismth.utils.decoder_init(outfile, faad_opt);
				if (success) {
					decoded = raismth.utils.read_temp(outfile);
					myDump('[RAISMTH] faad Decoder decoded length:' + decoded.length + '\n');
					raismth.faad_decoding_buffer[idx] = null;
					raismth.utils.clean_faad_temp_files(outfile);
				} else {
					myDump('[RAISMTH] faad Decoder >>>>> FAAD Decoder timeout FIXME <<<<<\n');
				}
			} 
		} else if(outfile.indexOf(raismth.video_ext[idx][clip]) > 0 && avc) {
			decoded = raismth.utils.decode_avc(data);
		}
		return decoded;
	},

	write_h264_tag : function(outfile) {
                let hdr = raismth.utils.manifest2bin(raismth.utils.h264_header());
                let stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
                stream.init(outfile, 0x02, 0666, 0);
                stream.write( hdr, hdr.length );
                stream.close();
                return false;
        },

        write_bin : function(data, outfile, idx, clip, ql, h264) {
                if(data) {
			raismth.writing[idx] = true;
			let decoded = raismth.utils.decode_data(data, outfile, idx, clip);
			data = decoded
			if(data != null) {
				let target = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				let path = raismth.temp_folder.path + raismth.sep + outfile;				
				target.initWithPath( path );
				let stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);	
				// try{
					if(h264) h264 = raismth.utils.write_h264_tag(target); 					
					if(!h264) {					
						stream.init(target, 0x02 | 0x10, 0666, 0);
						stream.write( data, data.length );
						stream.close();	
					}
				// } catch(e) {
					// myDump('[RAISMTH] Exception : ' + e + '\n');
				// }
			}
			raismth.writing[idx] = false;
			return true;
                }
		raismth.writing[idx] = false;
                myDump('[RAISMTH] write_bin : payload is null\n');
                return false;
        },

	h264_header : function() {
		let header = 'FF00A101C3D7034F9677';
		return header;
	},

	avc_header : function() {
		let header = '00000001674d401f965605a1afcf80a040000003004000000cb888002dc60000b7187f18e0ed0a15700000000168eacd48';
		return header;
	},

      	vcodec_init : function (indice, clip, ql) {					      
		let ref = clip;			      
		let header = false;
		clip = 2 * clip;
		myDump('[RAISMTH] ' + clip + ' <----CLIP ' + indice + ' <----INDICE\n');
		myDump('[RAISMTH] ' + raismth.stream_index[indice].toString() + '\n');
		let codec_private_data = raismth.stream_index[indice][clip][ql][2];
		if(raismth.stream_index[indice][clip][ql][3].toLowerCase() == 'avc1' || raismth.stream_index[indice][clip][ql][3].toLowerCase() == 'h264') {
			header = raismth.utils.manifest2bin(codec_private_data);
		} else {
		}
		return header;
	},

        vfile_init  : function(vfile, indice, clip, ql) {
		let header = raismth.utils.vcodec_init(indice, clip, ql);
                let v_file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		let fileext = raismth.video_ext[indice][clip];
		// '.vc1';
		// if(raismth.video_encoding[indice][clip] == 'avc1') fileext = '.avc';
		let path = raismth.temp_folder.path + raismth.sep + vfile + fileext;
                v_file.initWithPath( path );
		let success = false;
                try{
                        if(v_file.exists()) {
				v_file.remove(false);
				myDump('[RAISMTH] ' + path + ' removed\n');
			}
                        v_file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);
                }catch(e){
			myDump('[RAISMTH] Temp directory access denied: ' + e + '\n');
                }finally{
			if(header) {
				let stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
				stream.init(v_file, 0x02 | 0x08 | 0x10, 0666, 0);
				stream.write(header, header.length);
				stream.close();
			}			
                        myDump('[RAISMTH] Video file init OK\n');
                        success = true;
                }
		return success;
        },

	wave_header : function() {
                let AudioHdr  = "\x52\x49\x46\x46";     // 'RIFF'
                AudioHdr += "\x30\xFF\xFF\xFF";         // chunk size
                AudioHdr += "\x57\x41\x56\x45";         // 'WAVE'
                AudioHdr += "\x66\x6D\x74\x20";         // 'fmt '
                AudioHdr += "\x1C\x00\x00\x00";         // sub chunk size 28
                AudioHdr += "\x61\x01";                 // audio format 353
                AudioHdr += "\x02\x00";                 // num channels 2
                AudioHdr += "\x80\xBB\x00\x00";         // sample rate 48000
                AudioHdr += "\xC0\x5D\x00\x00";         // byte rate 24000 = bit rate 192000
                AudioHdr += "\x00\x20";                 // block size 8192
                AudioHdr += "\x10\x00";                 // bits per sample 16
                AudioHdr += "\x0A\x00";                 // extra param len 10
                AudioHdr += "\x00\x88\x00\x00\x0F\x00\x00\x00\x00\x00"; // extra param = codec private data = 008800000f0000000000
                AudioHdr += "\x64\x61\x74\x61";         // 'data'
                AudioHdr += "\xFF\xFF\xFF\x7F";         // sub chunk size
		return AudioHdr;
	},		

	acodec_init : function(indice, clip, ql) {
		let ref = clip;			      
                let header = false;
		clip = (2 * clip) + 1;
                if(raismth.stream_index[indice][clip][0][3].toLowerCase() === 'aacl') {
		} else {
			// FIXME
			header = raismth.utils.wave_header();
		}
                return header;
	},

        afile_init : function(afile, indice, clip, ql) {
		let header = raismth.utils.acodec_init(indice, clip, ql);
                let a_file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		let fileext = raismth.audio_ext[indice][clip];
		// let fileext = '.wav';
		// if(raismth.audio_encoding[indice][clip] == 'aacl') fileext = '.aac';
                let path = raismth.temp_folder.path + raismth.sep + afile + fileext;
                a_file.initWithPath( path );
		let success = false;
                try{
                        if(a_file.exists()) {
				a_file.remove(false);
				myDump('[RAISMTH] ' + path + ' removed\n');
			}
                        a_file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);
                }catch(e){
			myDump('[RAISMTH] Temp directory access denied: ' + e + '\n');
                }finally{
			if(header) {
	                        let stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	                        stream.init(a_file, 0x02 | 0x08 | 0x10, 0666, 0);
	                        stream.write(header, header.length);
	                        stream.close();
			}
			
                        myDump('[RAISMTH] Audio file init OK\n');
                        success = true;
                }
		return success;
        },

	clean_faad_temp_files : function(name) {
		let temp_files = [ '.tmp', '.aac' ];
		for (let c = 0; c < temp_files.length; c++) {
			let file_name = raismth.temp_folder.path + raismth.sep + name + temp_files[c];
			myDump('[RAISMTH] ' + file_name + '\n');
			let file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath( file_name );
			let success = false;
			try{
				if(file.exists()) {
					file.remove(false);
					myDump('[RAISMTH] faad temp file ' + file_name + ' removed\n');
				}
			} catch(e) {
			}
		}
	},		   			
	clean_temp_files : function(pid) {
		let temp_files = [ '.vc1', '.wav', '.avc', '.aac', '.264' ]; // , '.aac.tmp', '.aac.aac' ];
		for (let c = 0; c < temp_files.length; c++) {
			let file_name = raismth.temp_folder.path + raismth.sep + pid + temp_files[c];
                	let file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath( file_name );
			let success = false;
			try{
				if(file.exists()) {
					file.remove(false);
					myDump('[RAISMTH] temp file ' + file_name + ' removed\n');
				}
			} catch(e) {

			}
		}
	},	      			  
			   
        tabselect : function(event) {
                let browser = gBrowser.getBrowserForTab(event.target);

                let uri = browser.currentURI.asciiHost;
                myDump('[RAISMTH] TabSelect event: ' + uri + '\n');
                if (uri.match(/(|www\.)rai\..*/i)) {
                        myDump('[RAISMTH] Rai tab selected\n');
                } else {
                        myDump('[RAISMTH] Generic tab selected\n');
                }
        },

	tabMonitor : function(event) {
		let doc = gBrowser.getBrowserForTab(event.target).contentDocument;
	        let ts = doc.getElementById('raismthWindow').getAttribute('name');
		let indice = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(ts));
		myDump('[RAISMTH] tabMonitor - ts:' + ts + ' indice:' + indice + '\n');
		raismth.streams[indice] = null;
		raismth.smthsem[indice] = false;
		raismth.utils.purge_arrays(doc);
		raismth.player_istances[indice].kill();
	},

        checkRaiTabs : function(){
                let num = gBrowser.browsers.length;
                let res = false;
                for (let i = 0; i < num; i++) {
                        let b = gBrowser.getBrowserAtIndex(i);
                        try {
                                if(b.currentURI.spec.match(/(|www\.)rai\..*/i)) {
                                        myDump('--[RAISMTH] Rai Tab(s) open: ' + b.currentURI.spec + '\n');
                                        res = true;
                                }
                        } catch(e) {
                                Components.utils.reportError(e);
                                myDump('[RAISMTH] ' + e + '\n');
                        }
                }
                return res;
        },

        IsRaiPage : function(doc) {
		if (doc.location && doc.location.href.match(/http:\/\/(|www\.)(.*?)rai\..*\/.*/i)){			    
                // if (doc.location && doc.location.href.match(/http:\/\/(|www\.)rai\..*\/.*/i)){
                        return true;
                } else {
                        return false;
                }
        },

        trim : function(str){
                return str.replace(/^\s+|\s+$/g,"");
        },

        pad : function (str, length) {
                str = '' + str;
                while (str.length < length) {
                        str = str + '\u00A0';
                }
                return str;
        },

        padString : function(n) {
                let ret = (n<10) ? '0' + n : n;
		return ret;
        },

	bin2Hex : function(s) {
                var i, f = 0;
                var a = [];
                s += '';
                f = s.length;
                for (i = 0; i < f; i++) {
			a[i] = s.charCodeAt(i); // & 0xFF;
			a[i] = a[i].toString(16).replace(/^([\da-f])$/, "0$1");
		}
                var b = a.join('');
                b = parseInt(b, 16);
                return b;
	},

        bin2hex : function(s) {
                var i, f = 0;
                var a = [];
                s += '';
                f = s.length;
                for (i = f - 1; i >= 0; i--) {
                        a[i] = s.charCodeAt(i) & 0xFF;
                        a[i] = a[i].toString(16).replace(/^([\da-f])$/, "0$1");
                }
                var b = a.join('');
                b = parseInt(b, 16);
                return b;
        },

	manifest2bin : function(s) {
		let f = '';
		for(let c = 0; c < s.length; c+=2) {
			f += String.fromCharCode(parseInt(s.substr(c, 2), 16));
		}
		return f;
	},	

        arrayIndexOf : function (array, pattern) {
                let indice; //contatore
                for (indice in array) {
                        if (array[indice] === pattern)
                                return indice;
                }
                return -1;
        },
	
	purge_arrays : function(doc) {
		myDump('[RAISMTH] ' + raismth.rai_windows_ts.toString() + ' <-ts array before\n');
		myDump('[RAISMTH] ' + raismth.rai_windows.toString() + ' <-dom array before\n');		
		let ts = doc.getElementById('raismthWindow');
		if(ts) {
			ts = ts.getAttribute('name');
			let indice = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(ts));
			raismth.rai_windows_ts[indice] = null; 
			raismth.rai_windows[indice] = null; 
		}
		myDump('[RAISMTH] ' + raismth.rai_windows_ts.toString() + ' <-ts array after\n');                      
		myDump('[RAISMTH] ' + raismth.rai_windows.toString() + ' <-dom array after\n'); 

	},		       
		       
        kill_refresh : function(doc) {
		let jso = myWrapper(doc);
		jso.tryAutoRefresh = function() { };
	},

};

}});
